#!/bin/bash
# block ssh brute force attacks
# Author: Alex Celi alex@linux.org.pe
# Tested on Centos 5

LOGFILE="/var/log/secure"
HOSTSDENY="/etc/hosts.deny"
BADCOUNT="10"

grep "Failed password" $LOGFILE | sed s/"invalid user "/""/ |  cut -d':' -f 4 | cut -d' ' -f7 | sort | uniq -c | while read i
do
        count=`echo $i | cut -d" " -f1`
        ip=`echo $i | cut -d" " -f2`
#       echo "count="$count
#       echo "ip="$ip
        already=`grep $ip $HOSTSDENY | grep sshd`
        if [ -z "$already"  ]
        then
                if [ "$count" -ge "$BADCOUNT" ]
                then
                        echo "banned from sshd: "$ip
                        echo "sshd: "$ip >> $HOSTSDENY
                fi
        fi
done

